#include <cstring>

#include "b_FEN.h"
#include "e_Move_816.h"
#include "d_Rules_816.h"

//-----------------------------------------------------------------------------------
/* ++
 *      fen 
 *
 *  ChessTerminator75
 *   21.07.2007
 *
 *  
 *   
 *     b_Protokol_UCI
 *        
 *    UCI 
 */
//---------------------------------------------------------------------------
 T_list_surplus_moves list_surplus_moves_f;//  
//	===================================================================
//       
void parse_position(const char string_in[],T_board_list_816 * board_list_816){
//        
//"position startpos"   
//"position startpos moves b1c3 b8c6 g1f3 g8f6"   +     
//"position fen 1k1r4/8/8/8/8/8/8/3R2K1 w - - 0 1 "     

// T_list_surplus_moves list_surplus_moves;//  
 char * fen;  //   fen
 char * moves;//   moves
 char * ptr;  //  
 char move_string[]={' ',' ',' ',' ',' ',' ',' '};//  
 //  -
 char * StartFen = "fen rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1 ";

//    fen
   fen = strstr(string_in,"fen ");
//    moves
   moves = strstr(string_in,"moves ");

   if (fen != NULL) { // "fen"   
//     -
      board_from_fen(board_list_816,fen);
   } else {
//      startpos
//             
// StartFen = "fen rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1";
     board_from_fen(board_list_816,StartFen);
   }// if (fen != NULL)

//    
//moves g1f3 d7d5 b2b3 c8g4 c1b2 b8c6 h2h3 
   if (moves != NULL) { //   "moves" 
      //  moves 
      ptr = moves + 6;

      while (*ptr != '\0') { 
         move_string[1] = *ptr++;
         move_string[2] = *ptr++;
         move_string[3] = *ptr++;
         move_string[4] = *ptr++;

       if (*ptr == '\0' || *ptr == ' ') {
         move_string[5] = '\0';
       } else { // 
         move_string[5] = *ptr++;
         move_string[6] = '\0';
       }//if (*ptr == '\0' || *ptr == ' ') {
         board_from_move(board_list_816,move_string,&list_surplus_moves_f);
         while (*ptr == ' ') ptr++;
      }//while (*ptr != '\0') {
    }//if (moves != NULL)

fen   = NULL;
moves = NULL;
ptr = NULL;
StartFen = NULL;

}//parse_position(char string_in[]){
//	*******************************************************************

//	===================================================================
//         Ch_Koordinata_To_Indeks
void board_from_fen(T_board_list_816 * board_list_816,/* const*/ char fen[]){
//     "position fen 1k1r4/8/8/8/8/8/8/3R2K1 w - - 0 1 "
//  /    
//       
//            
 
  int i=0;
//  fen
  while (fen[i]!=' '){
	  i=i+1;
  }//while (fen[i]!=' '){

//  
  while (fen[i]==' '){
	  i=i+1;
  }//while (fen[i]!=' '){

//-----------------------------------------------------------------------------------	
// 1     -     

//      8  8  9-     
for (int y1=0 ;y1<8;y1++){
 for (int x1=8 ;x1<16;x1++){
   board_list_816->name_figure_816[(16*y1+x1)]=9;
 }//for (int x=1 ;x<9;x++){
}//for (int y=1 ;y<9;y++){
//-------------------------------------------
//      8  8  3-     
for (int y1=0 ;y1<8;y1++){
 for (int x1=8 ;x1<16;x1++){
   board_list_816->colour_figure_816[(16*y1+x1)]=3;
 }//for (int x=1 ;x<9;x++){
}//for (int y=1 ;y<9;y++){
//-------------------------------------------

//            xy- 
int y=0;
int x=0;
int void_q;//   
// 1k1r4/8/8/8/8/8/8/3R2K1 w - - 0 1
//    ..  
while(fen[i]!=' '){
	x=0;
//--------------------
//      
	while((fen[i]!='/')&&(fen[i]!=' ')){
// 0-  1- 2- 3- 4- 5- 6-	
// 1-   2 - 
	 switch(fen[i]){
// 
		case 'R'://
         board_list_816->name_figure_816[(16*y+x)]=2;
         board_list_816->colour_figure_816[(16*y+x)]=1;
		break;
		case 'N'://
         board_list_816->name_figure_816[(16*y+x)]=3;
         board_list_816->colour_figure_816[(16*y+x)]=1;	
		break;
		case 'B'://
         board_list_816->name_figure_816[(16*y+x)]=4;
         board_list_816->colour_figure_816[(16*y+x)]=1;
		break;
		case 'Q'://
         board_list_816->name_figure_816[(16*y+x)]=5;
         board_list_816->colour_figure_816[(16*y+x)]=1;
		break;
		case 'K'://
         board_list_816->name_figure_816[(16*y+x)]=6;
         board_list_816->colour_figure_816[(16*y+x)]=1;
		break;
		case 'P'://
         board_list_816->name_figure_816[(16*y+x)]=1;
         board_list_816->colour_figure_816[(16*y+x)]=1;
		break;
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
// 0-  1- 2- 3- 4- 5- 6-	
// 
		case 'r':
         board_list_816->name_figure_816[(16*y+x)]=2;
         board_list_816->colour_figure_816[(16*y+x)]=2;
		break;
		case 'n':
         board_list_816->name_figure_816[(16*y+x)]=3;
         board_list_816->colour_figure_816[(16*y+x)]=2;	
		break;
		case 'b':
         board_list_816->name_figure_816[(16*y+x)]=4;
         board_list_816->colour_figure_816[(16*y+x)]=2;
		break;
		case 'q':
         board_list_816->name_figure_816[(16*y+x)]=5;
         board_list_816->colour_figure_816[(16*y+x)]=2;
		break;
		case 'k':
         board_list_816->name_figure_816[(16*y+x)]=6;
         board_list_816->colour_figure_816[(16*y+x)]=2;
		break;
		case 'p':
         board_list_816->name_figure_816[(16*y+x)]=1;
         board_list_816->colour_figure_816[(16*y+x)]=2;
		break;
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
			
			default:

//-----------------------------------------------------------------
//        8  
//   '8'   Ch_Koordinata_To_Indeks   0     8 
//   (8-... 
		 void_q=(8-Ch_Koordinata_To_Indeks(fen[i]));
//    
         board_list_816->name_figure_816[(16*y+x)]=0;
         board_list_816->colour_figure_816[(16*y+x)]=0;
//   7 (      1+7=8    ) 
			for (int f=1;f<void_q;f++){
			 	x=x+1;
         board_list_816->name_figure_816[(16*y+x)]=0;
         board_list_816->colour_figure_816[(16*y+x)]=0;
			}//for (int f=1;f<l;f++)
		}// switch(fen[i]){
//-----------------------------------------------------------------

		i=i+1;
		x=x+1;
	}//while((fen[i]!='/')&(fen[i]!=' ')){
//--------------------		
//    
	if(fen[i]!=' ')	{i=i+1;y=y+1;}
	  	
}//while(fen[i]!=' '){

//-----------------------------------------------------------------------------------	
//2     	
//  
  while (fen[i]==' '){
	  i=i+1;
  }//while (fen!='\0'){
// w -    b- 
	if (fen[i]=='w') board_list_816->colour_move = 1;
	if (fen[i]=='b') board_list_816->colour_move = 2;
//	-----------------------------------------------------------------------------------	
//	3   
	// 
	  i=i+2;
//              
    board_list_816->castling_Q =0;
    board_list_816->castling_K =0;
    board_list_816->castling_q =0;
    board_list_816->castling_k =0;

	while(fen[i]!=' '){	
		if (fen[i]=='K') board_list_816->castling_K =1;//   
		if (fen[i]=='Q') board_list_816->castling_Q =1;//   
		if (fen[i]=='k') board_list_816->castling_k =1;//   
		if (fen[i]=='q') board_list_816->castling_q =1;//   
		i=i+1;
	}
//	-----------------------------------------------------------------------------------
//	 4     
/*
     :
 And after the move 1. e4:
 rnbqkbnr/pppppppp/8/8/4P3/8/PPPP1PPP/RNBQKBNR b KQkq e3 0 1
         (  4   3)
*/
//  
  while (fen[i]==' '){
	  i=i+1;
  }//while (fen!='\0'){
//		               
//		        1	 
//  
		board_list_816->taking_passage_yes =0;
        board_list_816->taking_passage_x   =0;
        board_list_816->taking_passage_y   =0;

		if (fen[i]!='-'){
			board_list_816->taking_passage_yes =1;//  
			 board_list_816->taking_passage_x = Koordinata_To_Indeks(fen[i]);//  ( )
			i=i+1;
			 board_list_816->taking_passage_y = Ch_Koordinata_To_Indeks(fen[i]);//  () 	
		}//if (GUI_To_Engine_Text.charAt(i)!='-'){	
//---------------------------------------------------------------------------
}//board_from_fen(int chess_board[], const char fen[]){
//	*******************************************************************

//	===================================================================
//     ..       
void board_from_move(T_board_list_816 * board_list_816,char move_string[],T_list_surplus_moves * list_surplus_moves_f){

//    
//moves g1f3 d7d5 b2b3 c8g4 c1b2 b8c6 h2h3 
//    
list_surplus_moves_f->start_list[0]=1;
list_surplus_moves_f->end_list[0]=1;//   1   i        0  ?  
//   
short int n=16*Ch_Koordinata_To_Indeks(move_string[2])+Koordinata_To_Indeks(move_string[1]);
//    
short int name =board_list_816->name_figure_816[n];
//   
short int n_2=16*Ch_Koordinata_To_Indeks(move_string[4])+Koordinata_To_Indeks(move_string[3]);
//     
Rules_816(name,n,*board_list_816,list_surplus_moves_f);

//
short int n_3=0; //    
//     
for (int i=list_surplus_moves_f->start_list[0];i<list_surplus_moves_f->end_list[0];i++){
//          ..
	if (n_2== list_surplus_moves_f->final_position[i]){
     
//------------------
//       
//           
//    
	  switch (move_string[5]){
//         
   case '\0' :
   // 
   n_3 =i;
   break;
//    
   case 'r' :
   //
     n_3 =i;
   break;

   case 'n' :
   //
     n_3 =i+1;
   break;

   case 'b' :
   //
     n_3 =i+2;
   break;

   case 'q' :
   //
     n_3 =i+3;
   break;

   default:;//   
   
 }// switch (name){
//------------------

	 break;
	}//if (n== list_surplus_moves->final_position[i]){
}//for (i=1,i<list_surplus_moves->amount_moves+1){

//  
Onward_moves_816(n_3,list_surplus_moves_f,board_list_816);

}//void board_from_move(int chess_board[],char move_string){
//	*******************************************************************

//	===================================================================
//	    	
	short int Koordinata_To_Indeks(char ch){
			   if (ch =='a') return 0;
			   if (ch =='b') return 1;
			   if (ch =='c') return 2;
			   if (ch =='d') return 3;
			   if (ch =='e') return 4;
			   if (ch =='f') return 5;
			   if (ch =='g') return 6;
			   if (ch =='h') return 7;
			   return 777;
			  }
//	*******************************************************************

//	===================================================================
//	    	
	short int Ch_Koordinata_To_Indeks(int ch){
			   if (ch =='1') return 7;
			   if (ch =='2') return 6;
			   if (ch =='3') return 5;
			   if (ch =='4') return 4;
			   if (ch =='5') return 3;
			   if (ch =='6') return 2;
			   if (ch =='7') return 1;
			   if (ch =='8') return 0;
			   return 777;
			  }
//	*******************************************************************
